// Project 28 – Using CTC Timer for Repetitive Actions 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

ISR(TIMER1_COMPA_vect)
{   // Code to be executed when interrupt triggered from TIMER1 overflow
    // For this example, quickly blink LED on PB1
    TCNT1 = 0;          // reset TIMER1 back to zero
    PORTB = 0b00000010;    
    _delay_ms(10);
    PORTB = 0b00000000;   
}

void initCTC() 
// setup CTC interrupt and TIMER1
{
   OCR1A = 14649; // number of periods to watch for - 14649
   // turn on CTC mode and set CS12 and CS10 for /1024 prescaler
   TCCR1B = 0b00000101; 
   TIMSK1 = 0b00000010; // turn on timer compare interrupt
   sei(); // turn on global interrupts
}

int main(void)
{
    DDRB = 0b11111111; // set PORTB register as outputs
    initCTC();         // setup overflow interrupt and TIMER1
  
    for(;;)            // do something (blink LED on PB0)
    {
        PORTB = 0b00000001;    
        _delay_ms(100);
        PORTB = 0b00000000;
        _delay_ms(100);
    }
    return 0; 
}