// Listing 10-2

#include <avr/io.h>
#define __DELAY_BACKWARD_COMPATIBLE__
#include <util/delay.h>

void blinkType(int blinks, int duration)
// blinks - number of times to blink the LED
// duration – blink duration in milliseconds
{
    uint8_t i;	
    for (i = 0; i < blinks; i++)
    {
        PORTB |= (1 << PORTB0);
        _delay_ms(duration);
        PORTB &= ~(1 << PORTB0);
        _delay_ms(duration);
    }
}

int main(void)
{
    DDRB |= (1 << PORTB0); // set PORTB0 as output
    while (1) 
    {
        // blink LED ten times, with 150ms duration
        blinkType(10, 150);
        _delay_ms(1000);
		
        // blink LED five times, with one second duration
        blinkType(5, 1000);
        _delay_ms(1000);
    }
}