// Project 56 - Experimenting with Servos

#include <avr/io.h>
#include <util/delay.h>

void initPWM()
{    // activate PWM on PB1
    TCCR1A |= (1 << WGM11);
    TCCR1B |= (1 << WGM12)|(1 << WGM13)|(1 << CS11); 
	
    // connect PWM to PB1
    TCCR1A |= (1 << COM1A1); // PWM to OCR1A - PB1 
    ICR1=39999; 
}

void servoAngle(uint8_t angle)
{   // rotate servo to 'angle' position
    OCR1A = ((angle-239.95)/-0.05); // convert angle to OCR1A (duty cycle) value
}

void servoRange()
{
    OCR1A=4799; // zero degrees
    _delay_ms(1000);
    OCR1A=1199; // 180 degrees
    _delay_ms(1000);  
}

int main()
{
    DDRB|=(1<<PB1);
    initPWM();
    uint8_t i;

    while(1)
    {
        servoRange();
        _delay_ms(1000);
	
        for (i=0; i<=180; i++)
        {
            servoAngle(i);
            _delay_ms(25);
        }		
        for (i=180; i>0; --i)
        {
            servoAngle(i);
            _delay_ms(5);
        }	
    }
} 