// Project 58 - Experimenting witah Two Servos

#include <avr/io.h>
#include <util/delay.h>

void initPWM()
{    // activate PWM
    TCCR1A |= (1 << WGM11);
    TCCR1B |= (1 << WGM12)|(1 << WGM13)|(1 << CS11); 
	
    // connect PWM to PB1 and PB2
    TCCR1A |= (1 << COM1A1)|(1 << COM1B1); // PWM to OCR1A - PB1 and OCR1B - PB2
    ICR1=39999; 
}

void servoAngleA(uint8_t angle)
{    // rotate servo on OCR1A to 'angle' position
    OCR1A = ((angle-239.95)/-0.05); // convert angle to OCR1A (duty cycle) value
}

void servoAngleB(uint8_t angle)
{    // rotate servo on OCR1B to 'angle' position
    OCR1B = ((angle-239.95)/-0.05); // convert angle to OCR1A (duty cycle) value
}

void servoRange()
{
    OCR1A=4799; // zero degrees
    OCR1B=4799;
    _delay_ms(1000);
    OCR1A=1199; // 180 degrees
    OCR1B=1199; // 180 degrees	
    _delay_ms(1000);  
}

int main()
{
    DDRB|=(1<<PB1)|(1<<PB2); // set PB1 and PB2 to outputs
    initPWM();
    uint8_t i;
	
    while(1)
     {
        servoRange();
        _delay_ms(1000);
		
        for (i=0; i<=180; i++)
        {
            servoAngleA(i);
            servoAngleB(i);			
            _delay_ms(25);
        }		
        for (i=180; i>0; --i)
        {
            servoAngleA(i);
            servoAngleB(i);	
            _delay_ms(5);
        }	
    }
} 